<?php

namespace AppBundle\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

class Configuration implements ConfigurationInterface
{
    public function getConfigTreeBuilder()
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('app');

        $rootNode
            ->children()
                ->arrayNode('languages')
                    ->prototype('scalar')->end()
                ->end()
                ->arrayNode('sites_enabled')
                    ->children()
                        ->booleanNode('doku')
                            ->defaultValue(false)
                        ->end()
                        ->booleanNode('grav')
                            ->defaultValue(false)
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('blog')
                    ->children()
                        ->scalarNode('path_accounts')
                            ->defaultValue('%kernel.project_dir%/blog/users')
                        ->end()
                        ->scalarNode('path_grav')
                            ->defaultValue('%kernel.project_dir%/grav')
                        ->end()
                        ->scalarNode('limit_per_user')
                            ->defaultValue(1)
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('wiki')
                    ->children()
                        ->scalarNode('path_accounts')
                            ->defaultValue('%kernel.project_dir%/wiki/users')
                        ->end()
                        ->scalarNode('path_doku')
                            ->defaultValue('%kernel.project_dir%/dokuwiki')
                        ->end()
                        ->scalarNode('limit_per_user')
                            ->defaultValue(1)
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('single_page')
                    ->children()
                        ->scalarNode('path_accounts')
                            ->defaultValue('%kernel.project_dir%/single_page/users')
                        ->end()
                        ->scalarNode('path_pretty_noemie')
                            ->defaultValue('%kernel.project_dir%/pretty_noemie')
                        ->end()
                        ->scalarNode('limit_per_user')
                            ->defaultValue(1)
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('gandi')
                    ->children()
                        ->scalarNode('mode')
                            ->defaultValue('test')
                        ->end()
                        ->arrayNode('default_zone')
                            ->children()
                                ->scalarNode('test')
                                ->end()
                                ->scalarNode('prod')
                                ->end()
                            ->end()
                        ->end()
                        ->arrayNode('key')
                            ->children()
                                ->scalarNode('test')
                                ->end()
                                ->scalarNode('prod')
                                ->end()
                            ->end()
                        ->end()
                        ->arrayNode('id')
                            ->children()
                                ->scalarNode('test')
                                ->end()
                                ->scalarNode('prod')
                                ->end()
                            ->end()
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('stripe')
                    ->children()
                        ->scalarNode('mode')
                            ->defaultValue('test')
                        ->end()
                        ->arrayNode('key')
                            ->children()
                                ->arrayNode('test')
                                    ->children()
                                        ->scalarNode('private')
                                        ->end()
                                        ->scalarNode('public')
                                        ->end()
                                    ->end()
                                ->end()
                                ->arrayNode('prod')
                                    ->children()
                                        ->scalarNode('private')
                                        ->end()
                                        ->scalarNode('public')
                                        ->end()
                                    ->end()
                                ->end()
                            ->end()
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('framasoft')
                    ->children()
                        ->scalarNode('marge')
                            ->defaultValue(0.1)
                        ->end()
                        ->arrayNode('bank')
                            ->children()
                                ->scalarNode('iban')
                                ->end()
                                ->scalarNode('bic')
                                ->end()
                                ->scalarNode('owner_name')
                                ->end()
                                ->scalarNode('owner_address')
                                ->end()
                            ->end()
                        ->end()
                        ->scalarNode('buy_domains')
                            ->defaultValue(false)
                        ->end()
                        ->scalarNode('address')
                            ->defaultValue('')
                        ->end()
                        ->scalarNode('email')
                            ->defaultValue('')
                        ->end()
                    ->end()
                ->end()
                ->arrayNode('registration')
                    ->children()
                        ->booleanNode('enabled')
                            ->defaultValue(false)
                        ->end()
                        ->scalarNode('suffix')
                            ->defaultValue(false)
                        ->end()
                    ->end()
                ->end()
            ->end()
        ;

        return $treeBuilder;
    }
}
